// Copyright 2003 Regents of the University of California

// SETI_BOINC is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2, or (at your option) any later
// version.

// SETI_BOINC is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.

// You should have received a copy of the GNU General Public License along
// with SETI_BOINC; see the file COPYING.  If not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "config.h"
#include "sqlapi.h"

#ifdef USE_NAMESPACE
#if defined(USE_INFORMIX)
using namespace ifx;
#elif defined(USE_MYSQL)
using namespace mysql;
#endif
#endif


int main(int ac, char **av) {
  SQL_CURSOR fd;
  SQL_CURSOR fd2;
  int ret = 0;
  SQL_ROW argv;
  SQL_ROW argv2("19",1);
  SQL_ROW argv3;
  int num;
  sql_database("ni");
  fd = sql_open("select * from com_ne_defn",
                 argv);
  while (ret = sql_fetch(fd)) {
    if (ret) sql_print(fd);
  }
  printf("1st done\n");
  argv3 = sql_values(fd, &num);
  if (!(argv3.size()) ) printf("No values for fd%d\n", fd);
  else {
    int i;
    for (i = 0; i < num; i++)
      printf("Value %d is %s\n", i, argv3[i]);
  }
  fd2 = sql_open("select ne_id from com_ne_defn where ne_id matches ?",
                 argv);
  ret = true;
  while (ret ) {
    ret = sql_fetch(fd2);
    if (ret) sql_print(fd2);
  }
  printf("2nd done\n");

  if (sql_exists("com_ne_defn", "ne_id", 0, 0))
    printf("at least 1 ne exists\n");
  if (sql_exists("com_ne_defn", "ne_id", "AUSTT2", 0))
    printf("ne AUSTT2 exists\n");
  if (sql_exists("com_ne_defn", "ne_id", 0, "ne_id matches 'A*'"))
    printf("ne matching A* exists\n");
  if (sql_run("set lock mode to wait"))
    printf("successful lock mode\n");
  if (sql_run("update com_expected set xxxx = ?", argv2))
    printf("successful update \n");
  return(0);
}
